include("addresses.lua");
include("functions.lua");
include("settings.lua");
include("language/english.lua");
include("classes/waypoint.lua");
include("classes/waypointlist.lua");
setStartKey(settings.hotkeys.START_BOT.key);
setStopKey(settings.hotkeys.STOP_BOT.key);

attach(getWin());
updatecoords()
updatehp()
setwindow()

function main()

	local function list_waypoint_files()

		local hf_counter = 0;
		local pathlist = { }

		local function read_subdirectory(_folder)
			local subdir = getDirectory(getExecutionPath() .. "/waypoints/".._folder);
			if( not subdir) then return; end

			for i,v in pairs(subdir) do
				if( string.find (v,".xml",1,true) ) then
					hf_counter = hf_counter + 1;
						pathlist[hf_counter] = { };
						pathlist[hf_counter].folder = _folder;
						pathlist[hf_counter].filename = v;
				end
			end

		end		-- end of: local function read_subdirectory(_folder)


		local function concat_filename(_i, _folder, _filename)

			local hf_newname;
			local hf_folder = "";
			local hf_dots = "";
			local hf_slash = "";

			if( _folder  and  string.len(_folder) > 8 )  then
				hf_folder = string.sub(_folder, 1, 6);
				hf_dots = "..";
				hf_slash = "/";
			elseif( _folder  and  string.len(_folder) > 0 )  then
				hf_folder = _folder;
				hf_slash = "/";
			end

			hf_newname = sprintf("%s%s%s%s",
			  hf_folder,
			  hf_dots,
			  hf_slash,
			  _filename);

			hf_nr = sprintf("%3d:", _i);

			return hf_nr, hf_newname;

		end

		-- choose a path from the waypoints folder
		local dir = getDirectory(getExecutionPath() .. "/waypoints/")

		cprintf(cli.green,language[144], getExecutionPath());	-- Waypoint files in %s


		-- copy table dir to table pathlist
		-- select only xml files
		pathlist[0] = { };
		pathlist[0].filename = "wander";
		for i,v in pairs(dir) do

			-- no . means perhaps folder
			if( not string.find (v,".",1,true) ) then
				read_subdirectory(v);

			-- only list files with extension .xml
			elseif( string.find (v,".xml",1,true) ) then
				hf_counter = hf_counter + 1;
				pathlist[hf_counter] = { };
				pathlist[hf_counter].filename = v;
			end
		end

		local inc = math.ceil(#pathlist/3);

		for i = 0, inc do

			local column1 = ""; local column2 = ""; local column3 = "";
			local col1nr = ""; local col2nr = ""; local col3nr = "";

			col1nr, column1 = concat_filename(i, pathlist[i].folder, pathlist[i].filename)

			if ( (i + inc) <= #pathlist ) then
				col2nr, column2 = concat_filename(i+inc, pathlist[i+inc].folder, pathlist[i+inc].filename);
			end
			if ( (i+inc*2) <= #pathlist ) then
				col3nr, column3 = concat_filename(i+inc*2, pathlist[i+inc*2].folder, pathlist[i+inc*2].filename);
			end

			cprintf(cli.green,"%s %s %s %s %s %s\n",
				col1nr,
				string.sub(column1.."                    ", 1, 21),
				col2nr,
				string.sub(column2.."                    ", 1, 21),
				col3nr,
				string.sub(column3.."                    ", 1, 20) );

		end

		-- ask for pathname to choose
		keyboardBufferClear();
		io.stdin:flush();
		cprintf(cli.green,language[145], getKeyName(_G.key.VK_ENTER) );	-- Enter the number of the path
		local hf_choose_path_nr = tonumber(io.stdin:read() );
		if( hf_choose_path_nr and
			hf_choose_path_nr >= 0 and
			hf_choose_path_nr <= #pathlist ) then
			printf(language[146], hf_choose_path_nr );	-- You choose %s\n
			if( pathlist[hf_choose_path_nr].folder ) then
				wp_to_load = pathlist[hf_choose_path_nr].folder.."/"..pathlist[hf_choose_path_nr].filename;
			else
				wp_to_load = pathlist[hf_choose_path_nr].filename;
			end

			return wp_to_load;
		else
			cprintf(cli.green,language[147]);	-- Wrong selection
			yrest(3000);
			return false;
		end

	end
	-- end of local function list_waypoint_files()
	
	filename = getExecutionPath() .. "/waypoints/"..list_waypoint_files()
	
	

	updatecoords()
	updatehp()
	__WPL = CWaypointList();
	__WPL:load(filename)
	__WPL:setWaypointIndex( __WPL:getNearestWaypoint(playerX, playerZ, playerY ) );

	
	
	--=== Start of the repeating code ===--
	while(true) do
	--just a loop pause since I commented out the moveto usage
	yrest(5000)
	--[[
		wp = __WPL:getNextWaypoint()
		wpnum = __WPL.CurrentWaypoint
		cprintf(cli.green, language[6], wpnum, wp.X, wp.Z)	-- Moving to waypoint	
		updatecoords()
		moveto(wp,100)
		__WPL:advance();
		
		-- Execute it's action, if it has one.
		if( wp.Action and type(wp.Action) == "string" and string.find(wp.Action,"%a") ) then
			local actionchunk = loadstring(wp.Action);
			assert( actionchunk,  sprintf(language[150], __WPL.CurrentWaypoint) )
			actionchunk();
		end]]
	end
	
end
startMacro(main, true);